/******************************************************************************
*  Filename:       rf_patch_mce_wmbus_ctmode.h
*  Revised:        $Date: 2016-11-14 16:19:08 +0100 (ma, 14 nov 2016) $
*  Revision:       $Revision: 17453 $
*
*  Description: RF core patch for CC13XX WMBUS C- and T-Mode
*
*  Copyright (c) 2015-2016, Texas Instruments Incorporated
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions are met:
*
*  1) Redistributions of source code must retain the above copyright notice,
*     this list of conditions and the following disclaimer.
*
*  2) Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*
*  3) Neither the name of the ORGANIZATION nor the names of its contributors may
*     be used to endorse or promote products derived from this software without
*     specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
*  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
*  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
*  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*  POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************/

#ifndef _RF_PATCH_MCE_WMBUS_CTMODE_H
#define _RF_PATCH_MCE_WMBUS_CTMODE_H

#include <stdint.h>
#include "../inc/hw_types.h"

#ifndef MCE_PATCH_TYPE
#define MCE_PATCH_TYPE static const uint32_t
#endif

#ifndef PATCH_FUN_SPEC
#define PATCH_FUN_SPEC static inline
#endif

#ifndef RFC_MCERAM_BASE
#define RFC_MCERAM_BASE 0x21008000
#endif

MCE_PATCH_TYPE patchWmbusTmodeMce[512] = { 
   0x2fcf60b3,
   0xff803f9d,
   0x02b30666,
   0x0fff00ff,
   0x5555003f,
   0x05140510,
   0x0004002a,
   0x00310018,
   0x00610047,
   0x0092007a,
   0x00ba00a8,
   0x00d000c7,
   0x00d600d4,
   0x001f0045,
   0x00e800f8,
   0x00c000d0,
   0x008800a8,
   0x00600078,
   0x00440057,
   0x00180031,
   0x00250004,
   0x05b205a2,
   0x05d305c3,
   0x05f405e3,
   0x06140604,
   0x06350625,
   0x06560646,
   0x06770666,
   0x06980687,
   0x06b806a8,
   0x06c906b8,
   0x06e906d9,
   0x070a06fa,
   0x0016071b,
   0x001c002c,
   0x000e0034,
   0x001a0026,
   0x000d0032,
   0x00190025,
   0x000b0031,
   0x00130023,
   0x00060029,
   0x0006000e,
   0x0002000e,
   0x00040008,
   0x0006000e,
   0x0006000a,
   0x0002000c,
   0x00040008,
   0x0006000c,
   0x0006000e,
   0x0002000e,
   0x0000000e,
   0x0006000e,
   0x0006000a,
   0x0002000e,
   0x0006000a,
   0x0007000e,
   0x0007000f,
   0x0003000d,
   0x00050009,
   0x0001000d,
   0x0007000f,
   0x0001000f,
   0x0005000f,
   0x0007000f,
   0x0007000b,
   0x0003000b,
   0x0007000b,
   0x0007000b,
   0x0007000f,
   0x0003000f,
   0x0007000f,
   0x0003000f,
   0x3d1f0007,
   0x00000000,
   0x000f0400,
   0x03840000,
   0x00f4000b,
   0x80000043,
   0x06702801,
   0x091e0000,
   0x00040514,
   0x02000000,
   0x00613e10,
   0x842f0000,
   0x007f177f,
   0xaaaaaaaa,
   0x2abcaaaa,
   0x72200000,
   0xa32d7248,
   0x73057303,
   0x73047203,
   0x72047306,
   0x72767376,
   0x8001c7c0,
   0x90010001,
   0x08019010,
   0x720c9001,
   0x720e720d,
   0x7100b0c0,
   0xa0c0b0f0,
   0x81327218,
   0x39521020,
   0x00200670,
   0x11011630,
   0x6c011401,
   0x60ea60e8,
   0x61a76153,
   0x60e860e8,
   0x60e960e8,
   0x72201210,
   0x7310730f,
   0x81817311,
   0x91800010,
   0x60c8b070,
   0x60de60de,
   0x67fac030,
   0xc282c931,
   0x1820c470,
   0x6e236f13,
   0x16121611,
   0xc48268f0,
   0x1820c5a0,
   0x120340fd,
   0x16126e23,
   0x60de68fa,
   0x94908160,
   0x39808140,
   0x10012a70,
   0x84321611,
   0xc0f38444,
   0xc200c0f5,
   0x41221c01,
   0x1c10c100,
   0x4d1a4118,
   0x18031013,
   0x1a131830,
   0x39121a10,
   0x61226915,
   0x612213f3,
   0x101513f3,
   0x1850c100,
   0x1a101a15,
   0x69203914,
   0x7100b0d8,
   0xa0d8b108,
   0xb480b200,
   0xb013b003,
   0xb012b002,
   0xb0d07229,
   0xb1007100,
   0x92908140,
   0xb1007100,
   0x22f08140,
   0x13f04532,
   0x413e1c03,
   0x94929293,
   0xb1007100,
   0x94949295,
   0xb1007100,
   0xa480b0d0,
   0xa0d17000,
   0x9760c030,
   0x9780c040,
   0xb0c1b0f1,
   0xb0f17100,
   0x7276a0c1,
   0xa002a003,
   0x730f7000,
   0x8ad17310,
   0x39613981,
   0xd0400611,
   0x67fa9861,
   0x91c0c100,
   0x8ad064fe,
   0x458822e0,
   0xb0f3b483,
   0xb484b0c3,
   0x91c0c030,
   0xb0d1b101,
   0x22d58ad5,
   0x12f5416e,
   0x22308090,
   0x81a04583,
   0xc4310850,
   0x6f121401,
   0x2252c063,
   0x1211417b,
   0x13f1617c,
   0xb10192c1,
   0x31127100,
   0x45771a13,
   0xa0d1616e,
   0xa0c3b101,
   0x60de6545,
   0xb480b0d0,
   0x9290c070,
   0x949078c0,
   0x7100b100,
   0xa0d0b100,
   0xb483a480,
   0xb0c3b0f3,
   0xa0c37100,
   0x60de6545,
   0xd0508611,
   0x67fa9861,
   0x72767376,
   0x72067248,
   0x72047202,
   0x73067305,
   0x123060de,
   0x78b091b0,
   0xb32d9390,
   0x67fac060,
   0xb006b0f8,
   0xb004b016,
   0xb002b014,
   0x7810b012,
   0x90509030,
   0x90407820,
   0x81409060,
   0x39803180,
   0x81413940,
   0x0431c0f3,
   0x1441c014,
   0x783182e0,
   0xc7c10410,
   0x92e01410,
   0x72767278,
   0x8ae07255,
   0xa3119300,
   0x93b0c030,
   0xb064b069,
   0xa0c6b0f6,
   0xa0d1b101,
   0xa0c1b0f1,
   0xb0c2b0f2,
   0x8441b486,
   0x1a101200,
   0xc0f00801,
   0x06121012,
   0x142e311e,
   0x69e23911,
   0x67ef789c,
   0xc00fc00a,
   0xc00b1a1f,
   0xc1b01a1b,
   0xc0209780,
   0x78789760,
   0x048d789d,
   0xc005c024,
   0xb205c006,
   0x7100b0f2,
   0x1e2ab88d,
   0x8af04634,
   0x311b3970,
   0x8210140b,
   0x46081ccb,
   0x46432220,
   0x420c2220,
   0x620eb760,
   0xb0f1a760,
   0x8b218b10,
   0x22710801,
   0x33154217,
   0xc00a3116,
   0x1e3a61fa,
   0x161a4213,
   0x821061fa,
   0x42202220,
   0x6222b760,
   0xb0f1a760,
   0x8b218b10,
   0x22710801,
   0x1e0a4230,
   0x3115462c,
   0x622e3316,
   0x31163115,
   0x61fac00a,
   0x422e1e3a,
   0x61fa161a,
   0x22108090,
   0x8ad0421b,
   0x464322c0,
   0x048110b1,
   0x97c108d1,
   0x1c4187d1,
   0xc0704e22,
   0x727867fa,
   0xa0c17276,
   0xc070b0f1,
   0xb20193b0,
   0x97c53135,
   0x313687da,
   0x87d997c6,
   0x95fa189a,
   0x8940b889,
   0x3d803180,
   0x3d201620,
   0x18088ae8,
   0x85f1c150,
   0x4a601e41,
   0x1810c061,
   0xc00cc00b,
   0x79a9673e,
   0x10a879ba,
   0x1808c100,
   0x1e1185f1,
   0x1e014e74,
   0x18b9467d,
   0x10b54e7d,
   0x1ca510c5,
   0x62864a7d,
   0x108a1a89,
   0x4e9618b9,
   0x18c510b5,
   0x4a961ca5,
   0x7a906286,
   0x4e9618c0,
   0x18b510c5,
   0x1c05c000,
   0x628e4a96,
   0xc0d0c0dc,
   0x10d56721,
   0x120d1ac5,
   0x6298185d,
   0xc1cc10cb,
   0x6721c0d0,
   0x120d10d5,
   0x6298185d,
   0x6298c00d,
   0xa5e0a486,
   0xc00b67d1,
   0xc006c00a,
   0xc009c007,
   0x22d08ad0,
   0x788946a4,
   0x048e7868,
   0x048d789d,
   0x9780c010,
   0xc2b0b764,
   0xb0f69760,
   0xb069b0f1,
   0x7100b0f2,
   0x1e2ab88d,
   0x8af046bd,
   0x311b3970,
   0x048b140b,
   0x42e11ceb,
   0x809062cd,
   0x46c32260,
   0x46d82210,
   0xc03062c9,
   0xb0f69760,
   0xc1c0b0f1,
   0x1cdb9780,
   0xa76046cd,
   0x8b10b760,
   0x08018b21,
   0x42d42271,
   0x62d7120a,
   0x42d21e3a,
   0x62b0161a,
   0xc0607220,
   0x7100b0f2,
   0x86016ada,
   0x96011611,
   0xb88961ca,
   0x161a7276,
   0xc00b78c4,
   0xb074c00e,
   0xb0f2b113,
   0xb88d7100,
   0x46fa1e2a,
   0x39708af0,
   0x140b311b,
   0x1e6e161e,
   0x1c4b470f,
   0xc016435a,
   0x630fc00e,
   0x43041066,
   0x089bc530,
   0x6f0114b0,
   0xc0069191,
   0x630fc017,
   0x430f1077,
   0xc00b164f,
   0x8150c007,
   0x430f1e00,
   0x4f0f1cf0,
   0x8b10631a,
   0x08018b21,
   0x43162271,
   0x62e9c00a,
   0x43141e3a,
   0x62e9161a,
   0xa0c2a205,
   0xa0c1b0f2,
   0xb113b0f1,
   0x1a10619a,
   0xc0c2c001,
   0x161c6fcd,
   0x673610b3,
   0x1a101051,
   0x161c6fcd,
   0x1c156736,
   0x6b2a4b31,
   0x10516334,
   0x6b2a1002,
   0x7000102d,
   0x4b3b1cd3,
   0x18d51035,
   0x10d57000,
   0x70001835,
   0x7100b0f2,
   0x8911b88e,
   0x4f461012,
   0x18211201,
   0x1c1b3131,
   0x101b4f4a,
   0x10128921,
   0x12014f4f,
   0x31311821,
   0x4f531c1c,
   0xc172101c,
   0x4f581c20,
   0xb3119308,
   0x70006b3e,
   0x7276b113,
   0x9780c070,
   0xb0f29760,
   0x80b07100,
   0x476a2230,
   0x22108090,
   0x635f4768,
   0x67fac080,
   0x7276b073,
   0x9780c030,
   0x9760c070,
   0x8a8367ef,
   0xc0018a94,
   0x1c1f1a11,
   0xc040437a,
   0x4b7b1cf0,
   0x78a0b011,
   0x89409390,
   0x3d803180,
   0x8a809550,
   0xa4888a91,
   0xc022a487,
   0x1c211801,
   0x14124f91,
   0x63924b8f,
   0x43921c01,
   0xb4874f91,
   0xb4886392,
   0xb041a04e,
   0xb5e0b061,
   0x80b0b113,
   0x47962230,
   0xb0f1b0c1,
   0xb0f2a0c2,
   0x7100b113,
   0xa760b04e,
   0x3120c090,
   0x13009780,
   0xb76091b0,
   0x7100b0f1,
   0xb0f67276,
   0xb0f1b0c6,
   0x1200a0c1,
   0x97801a10,
   0x9760c380,
   0x9760c280,
   0x22008090,
   0x815444c8,
   0x43b61e04,
   0xb0f69784,
   0x87818790,
   0x4bce1c01,
   0x1ef11801,
   0x87814bcc,
   0x97811af1,
   0xb0f67100,
   0x978116f1,
   0x7100a205,
   0xa0c6b0f6,
   0x961d619a,
   0x16c1c2a1,
   0x6fd1141d,
   0x3151101d,
   0x398082e0,
   0x97211401,
   0x10218332,
   0x39520671,
   0x14210632,
   0xc1b01611,
   0x301043e6,
   0x12709730,
   0x92dd6be8,
   0x94a08740,
   0x94b08750,
   0x87e07000,
   0x47f41e00,
   0x97e084a0,
   0x784094a0,
   0x785092d0,
   0x700094b0,
   0x88409850,
   0x47fb2200,
   0x7000b830
};

PATCH_FUN_SPEC void rf_patch_mce_wmbus_ctmode(void)
{
#ifdef __PATCH_NO_UNROLLING
   uint32_t i;
   for (i = 0; i < 512; i++) {
      HWREG(RFC_MCERAM_BASE + 4 * i) = patchWmbusTmodeMce[i];
   }
#else
   const uint32_t *pS = patchWmbusTmodeMce;
   volatile unsigned long *pD = &HWREG(RFC_MCERAM_BASE);
   uint32_t t1, t2, t3, t4, t5, t6, t7, t8;
   uint32_t nIterations = 64;

   do {
      t1 = *pS++;
      t2 = *pS++;
      t3 = *pS++;
      t4 = *pS++;
      t5 = *pS++;
      t6 = *pS++;
      t7 = *pS++;
      t8 = *pS++;
      *pD++ = t1;
      *pD++ = t2;
      *pD++ = t3;
      *pD++ = t4;
      *pD++ = t5;
      *pD++ = t6;
      *pD++ = t7;
      *pD++ = t8;
   } while (--nIterations);
#endif
}

#endif
